/*MODIFIED BY CM last modif 02/04/99*/
/*1.\input premia mble,end,endnobib in the .tex files*/
/*2.Takes no argument, but gets the premiadir through the environment variable PREMIADIR*/
/*	through a system call*/

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <ctype.h>
#include <signal.h>
#include <errno.h>


/*  Type of files:
    0 routine
    1 mod.c
    2 opt.c
    3 mod_opt.c
    4 common.c and all .h
    5 test */

#define MAX_FILES 10000
#define MAX_LEVEL 20

#ifndef _WIN32
#include <sys/stat.h>
#include <sys/types.h>
#include <dirent.h>
typedef struct dirent dir_type;
#define NLENGTH(dirent) ((int)strlen((dirent)->d_name))
#define DIR_OPT "DIRENT"
#define MAX_PATH_LEN 512
char *path_sep="/";
#endif

#define strequ(s1,s2) (strcmp((s1),(s2)) == 0)

#ifdef _WIN32
char *path_sep = "/";
char *path_sep3 = ":";
#define MAX_PATH_LEN _MAX_PATH
#include <io.h>
#include <direct.h>
#endif

/* Extension */
char *suffix_c_tex = "tex";
char *suffix_h_tex = "h.tex";
char *suffix_c_src_tex = "_src.tex";

char *suffix_h_src_tex = "h_src.tex";

char *suffix_c_doc_pdf = "_doc.pdf";
char *suffix_h_doc_pdf = "h_doc.pdf";
char *suffix_c_doc_tex = "_doc.tex";
char *suffix_h_doc_tex = "h_doc.tex";
char *suffix_c_docl_tex = "_docl.tex";
char *suffix_h_docl_tex = "h_docl.tex";
char *suffix_c_pdf = "pdf";
char *suffix_h_pdf = "h.pdf";
char *suffix_c_src_pdf = "_src.pdf";

char *suffix_h_src_pdf = "h_src.pdf";

char *suffix_h=".h";


/* Summury */
char *level_up     = "..";
char *summury_file = "summury_doc.tex";
FILE *summury;

/* General Files */
char *mod_f = "mod";
char *opt_f = "opt";

/* Routine Type */
#define MAX_TYPE 5
char *type_algo[MAX_TYPE] = { "fd" , "ap" , "cf" , "mc" , "tr" };

/* Main Path */
char *premiasrcdir;

/* Doc Path */
char *premiadocdir="Doc";


typedef struct
{
  int  level;
  int  char_match;
  int  type;
  int  routine;
  char name[MAX_PATH_LEN];
  char path[MAX_PATH_LEN];
} C_Files ;

typedef C_Files *Ptr_C_Files;
Ptr_C_Files list_c_files[MAX_FILES];

typedef struct
{
  int winner;
  int nb_true;
  int len_ref;
  char ref[MAX_PATH_LEN];
  char file_viewer[MAX_PATH_LEN];
  char winner_name[MAX_PATH_LEN];
  int maj[MAX_PATH_LEN];
} Param;



int nb_c_files=0,files_proc=0,level_dir=0;
int lineno,column;
void create_pdf_link(char *path,char *name,int nb_level,
                     char pdf_link[MAX_PATH_LEN],int flag);
int store_c_file(char filename[MAX_PATH_LEN],char path[MAX_PATH_LEN],
                 int nb_level);


int create_file_nobib_dir_doc(char *dir_abs,char *path,char *name);
int create_file_nobib_master_doc(char *dir_abs,char *path,char *name);



int type_alg(char *name)
{
  int i;

  char tmp[MAX_PATH_LEN];



  for(i=0;i < (int)strlen(name);i++)

    tmp[i] = tolower(name[i]);
  for(i=0;i<MAX_TYPE;i++)
    if(strncmp(type_algo[i],tmp,strlen(type_algo[i])) == 0)
      break;

  if(i<MAX_TYPE)
    return i;
  else
    return -1;
}



void Init_File_Name(char name[MAX_PATH_LEN])
{
  int i;
  for(i=0;i<MAX_PATH_LEN;i++)
    name[i]='\0';
}


void error(int type_err,char *msg)
{
  switch(type_err){
  case 1:
    fprintf(stderr,"\nMemory problem\n");

    getchar();
    exit(1);
  case 2:
    fprintf(stderr,"\n Path %s too long\n",msg);
    getchar();

    exit(1);
  case 3:
    fprintf(stderr,"\nDirectory %s unreadable\n",msg);
    getchar();

    exit(1);
  case 4:
    fprintf(stderr,"\nCannot open %s for reading\n",msg);
    getchar();

    exit(1);
  case 5:
    fprintf(stderr,"\nCannot open %s for writing\n",msg);
    getchar();

    exit(1);
  case 6:
    fprintf(stderr," Directory %s empty\n",msg);
    getchar();

    exit(1);
  case 7:
    fprintf(stderr," File %s is missing\n",msg);
    getchar();
	case 8:
		fprintf(stderr,"The environement variable PREMIADIR is undefined\n");
		getchar();
		exit(1);
  default:
    getchar();

    exit(1);
  }
}


void divide_path(char *s,int *l,char paths[MAX_LEVEL][MAX_PATH_LEN])
{
  int i,j,k;

  if(s[0] == *path_sep)
    i=1;
  else
    i=0;
  j=0;
  while(1)
    {
      k=0;
      while((s[i] != *path_sep) && (s[i] != '\0'))
        paths[j][k++] = s[i++];
      if((s[i] == '\0') || (s[i+1] =='\0'))
        break;
      else{
        i++;
        j++;
      }
    }
  *l = j+1;

}

void find_mod_opt(int i,int *m,int *o,int *mo)
{
  int l,j,k;
  char t[MAX_LEVEL][MAX_PATH_LEN];
  char tmp[MAX_PATH_LEN];
  char tmp1[MAX_PATH_LEN];
  char tmp2[MAX_PATH_LEN];

  char tmp3[MAX_PATH_LEN];


  for(j=0;j<MAX_PATH_LEN;j++){
    tmp[j]='\0';
    tmp1[j]='\0';

    tmp2[j] = '\0';
  }

  for(j=0;j<MAX_LEVEL;j++)
    Init_File_Name(t[j]);

  divide_path(list_c_files[i]->path,&l,t);
  j=0;
  while(t[l-1][j] != '_'){
    tmp[j] = tolower(t[l-1][j]);
    j++;
  }

  j++;
  k=0;
  while(t[l-1][k] != '\0'){
    tmp1[k] = tolower(t[l-1][k+j]);
    k++;
  }

  j=0;

  for(k=0;k<(int)strlen(list_c_files[j]->name);k++)
    tmp2[k] = tolower(list_c_files[j]->name[k]);

  while((j < nb_c_files) &&  ((strncmp(tmp,tmp2,strlen(tmp)) != 0) ||
															(list_c_files[j]->type != 1))) {
    j++;

    Init_File_Name(tmp2);
    for(k=0;k<(int)strlen(list_c_files[j]->name);k++)

      tmp2[k] = tolower(list_c_files[j]->name[k]);

  }

  if(j == nb_c_files)
    error(7,tmp);
  else
    *m = j;


  j=0;
  for(k=0;k<(int)strlen(list_c_files[j]->name);k++)
    tmp2[k] = tolower(list_c_files[j]->name[k]);

  for(k=0;k<(int)strlen(t[l-1]);k++)
    tmp3[k] = tolower(t[l-1][k]);

  while((j < nb_c_files) &&  ((strncmp(tmp3,tmp2,strlen(tmp3)) != 0) ||
															(list_c_files[j]->type != 3))) {
    j++;
    Init_File_Name(tmp2);
    Init_File_Name(tmp3);

    for(k=0;k<(int)strlen(list_c_files[j]->name);k++)
      tmp2[k] = tolower(list_c_files[j]->name[k]);

		for(k=0;k<(int)strlen(t[l-1]);k++)
      tmp3[k] = tolower(t[l-1][k]);
  }

  if(j == nb_c_files)
    error(7,t[l-1]);
  else
    *mo = j;

  j=0;
	Init_File_Name(tmp2);
	for(k=0;k<(int)strlen(list_c_files[j]->name);k++)
    tmp2[k] = tolower(list_c_files[j]->name[k]);
	
  while((j < nb_c_files) &&  ((strncmp(tmp1,tmp2,strlen(tmp1)) != 0) ||
															(list_c_files[j]->type != 2))) {
		
    j++;
    Init_File_Name(tmp2);
    for(k=0;k<(int)strlen(list_c_files[j]->name);k++)
      tmp2[k] = tolower(list_c_files[j]->name[k]);
  }

  if(j == nb_c_files)
    error(7,tmp1);
  else
    *o = j;


}


void dir_cpy(char *dir1,char *dir2,char *dir)
{
  if((*dir1 != '\0') && (*dir2 != '\0')){

    while(*dir++ = *dir1++)
      ;
    *(dir-1)=*path_sep;

    while(*dir++ = *dir2++)
      ;

    if(strlen(dir) > MAX_PATH_LEN -1 )
      error(2,dir);
  }
  else

    if(*dir1 == '\0')
      strcpy(dir,dir2);
    else

      strcpy(dir,dir1);

}


void dir_cat(char *dir1,char *dir2)
{
  int i;

  if((*dir2 != '\0') && (*dir1 != '\0')){

    i = strlen(dir1);
    *(dir1+i)=*path_sep;
    i++;
    while(*(dir1++ +i) = *dir2++)
      ;

    if(strlen(dir1) > MAX_PATH_LEN -1 )
      error(2,dir1);
  }

  else

    if(*dir2 != '\0')

      strcpy(dir1,dir2);

}

/* if system can use the directory structure we recursively
   localize the *.c *.h files */

#ifdef DIR_OPT
int treat_dir(char *dir_abs,char dir[MAX_PATH_LEN])
{
  dir_type     *dp;
  DIR          *dirp;
  char         rec_dir[MAX_PATH_LEN],current_dir[MAX_PATH_LEN];
  int          len_pp;


  if(strlen(dir_abs) + strlen(dir) +2 > MAX_PATH_LEN)
    error(2,dir_abs);
  dir_cpy(dir_abs,dir,current_dir);


  dirp = opendir(current_dir);

  if (dirp == NULL)
    return 0;
  else
    level_dir++;


  while ( (dp = readdir(dirp)) != NULL ) {

    if (strequ(dp->d_name,".") || strequ(dp->d_name,"..")) {
      continue;
    }
    if(strlen(dir) + strlen(dp->d_name) + 2 > MAX_PATH_LEN)
      error(2,dp->d_name);
    dir_cpy(dir,dp->d_name,rec_dir);

    if (treat_dir(dir_abs,rec_dir) == 0)
      if (strlen(dp->d_name) > 2)
        if ( ( ( *(dp->d_name + strlen(dp->d_name)-1) == 'h' ) ||
               ( *(dp->d_name + strlen(dp->d_name)-1) == 'c' )) &&
             ( *(dp->d_name + strlen(dp->d_name)-2) == '.' )){
          store_c_file(dp->d_name,dir,level_dir);
          nb_c_files++;
        }
  }
  closedir(dirp);
  level_dir--;
  return 1;
}
#endif

#ifdef _WIN32
char path_win[MAX_PATH_LEN]="";
int treat_dir(char dir[MAX_PATH_LEN])
{
  long                d;
  struct _finddata_t  rep;
  char                current_dir[MAX_PATH_LEN];
  int                 i;

  Init_File_Name(current_dir);
  _getcwd(current_dir,MAX_PATH_LEN);
  if(strlen(current_dir) + strlen(dir) +2 > MAX_PATH_LEN)
    error(2,current_dir);
  dir_cpy(current_dir,dir,current_dir);
  _chdir(current_dir);
  level_dir++;
  d = _findfirst("*",&rep);

  while (1) {

    if (strequ(rep.name,".") || strequ(rep.name,"..")) {
      if(_findnext(d,&rep) != 0)

				break;

      else

				continue;
    }

    if (rep.attrib == _A_SUBDIR) {
      if(path_win[0] == '\0')
        strcpy(path_win,rep.name);
      else
        dir_cat(path_win,rep.name);
      treat_dir(rep.name);
    } else {

      if (strlen(rep.name) > 2)
        if ( ( ( rep.name[strlen(rep.name)-1] == 'h' ) || ( rep.name[strlen(rep.name)-1] == 'H' ) ||
               ( rep.name[strlen(rep.name)-1] == 'c' ) || ( rep.name[strlen(rep.name)-1] == 'C' ) ) &&
             ( rep.name[strlen(rep.name)-2] == '.' )){
          store_c_file(rep.name,path_win,level_dir);
          nb_c_files++;
        }
    }
    if(_findnext(d,&rep) != 0)
      break;
  }
  _findclose(d);
  Init_File_Name(current_dir);
  dir_cpy(level_up,path_sep,current_dir);
  _chdir(current_dir);
  for(i=strlen(path_win)-1;i >= 0;i--)
    if(path_win[i] == *path_sep)
      break;
    else
      path_win[i]='\0';
  if(i != 0)
    path_win[i]='\0';
  level_dir--;
  return 1;
}
#endif

int store_c_file(char filename[MAX_PATH_LEN],char path[MAX_PATH_LEN],
                 int nb_level)
{
  int n,i;
  char t[MAX_LEVEL][MAX_PATH_LEN];

  if (nb_c_files < MAX_FILES ){
    if ((list_c_files[nb_c_files] = (C_Files *)malloc(sizeof(C_Files)))
        == NULL)
      error(1,"");

    list_c_files[nb_c_files]->level = nb_level;
    list_c_files[nb_c_files]->char_match = 0;

    strcpy(list_c_files[nb_c_files]->name,filename);

    strcpy(list_c_files[nb_c_files]->path,path);
    for(i=0;i<MAX_LEVEL;i++)
      Init_File_Name(t[i]);

    divide_path(path,&n,t);
    if(((strequ(t[0],"mod")) || (strequ(t[0],"MOD"))) && (strncmp(t[n-1],filename,
																																	strlen(t[n-1]))!=0))
      {
        list_c_files[nb_c_files]->type = 0;
        list_c_files[nb_c_files]->routine = type_alg(filename);
      } else {
        list_c_files[nb_c_files]->routine = -1;
        if((filename[strlen(filename)-1] == 'h') ||
           ((!strequ(t[0],"mod")) && (!strequ(t[0],"MOD")))

           && ((!strequ(t[0],"opt")) && (!strequ(t[0],"OPT"))))
          list_c_files[nb_c_files]->type = 4;
        else{
          if((strequ(t[0],"opt")) || (strequ(t[0],"OPT")))
            list_c_files[nb_c_files]->type = 2;
          else{
            if(nb_level == 2)
              list_c_files[nb_c_files]->type = 1;
            else
              if(strlen(filename) == strlen(t[n-1]) + 2)
                list_c_files[nb_c_files]->type = 3;
              else
                list_c_files[nb_c_files]->type = 5;

          }
        }
      }
  } else {
    printf("Number of files to important\n");
    printf("Recompile the program with a higher MAX_FILES\n");
    exit(1);
  }


  return 0;
}


int getchar_n(FILE *f_c,FILE *f_tex)
{
  int c;

  while(1)
    switch (c = getc(f_c)) {
    case '\r':break;
    case '\n':
      lineno++;
      column = 1;
      return c;
    case '\t': column+=2;
    default:
      column++;
      return c;
    }
}

void fputc_tex(int c,int isup,FILE *f_tex)
{
  if(column>50){
    fputs("\n    ",f_tex);
    column = 3;
    lineno++;
  }

  switch(c){
  case '\t':
    fputs("  ",f_tex);
    break;
  case EOF:
    break;
  case '{':
    fputs("\\verb|{|",f_tex);
    break;
  case '}':
    fputs("\\verb|}|",f_tex);
    break;
  case '\\':
    fputs("\\verb|{|",f_tex);
    break;
  default:
    if(isup == 0)
      fputc(c,f_tex);
    else
      fputc(toupper(c),f_tex);
    break;
  }

}
void c_name_to_tex_name(char *c_name,char *tex_name)
{
  while(*tex_name++ = *c_name++)
    ;

  if((*(c_name-2) == 'c') || (*(c_name-2) == 'C'))
    strcpy(tex_name-3,suffix_c_src_tex);
  else
    strcpy(tex_name-3,suffix_h_src_tex);
}
void c_name_to_pdf_doc_name(char *c_name,char *tex_name)
{
  while(*tex_name++ = *c_name++)
    ;

  strcpy(tex_name-3,suffix_c_doc_pdf);
}
void c_name_to_tex_docl_name(char *c_name,char *tex_name)
{
  while(*tex_name++ = *c_name++)
    ;

  if((*(c_name-2) == 'c') || (*(c_name-2) == 'C'))
    strcpy(tex_name-3,suffix_c_docl_tex);
  else
    strcpy(tex_name-3,suffix_h_docl_tex);
}
void c_name_to_tex_doc_name(char *c_name,char *tex_name)
{
  while(*tex_name++ = *c_name++)
    ;

  if((*(c_name-2) == 'C') || (*(c_name-2) == 'c'))
    strcpy(tex_name-3,suffix_c_doc_tex);
  else
    strcpy(tex_name-3,suffix_h_doc_tex);
}

void c_name_to_pdf_name(char *c_name,char *pdf_name)
{
  while(*pdf_name++ = *c_name++)
    ;

  if((*(c_name-2) == 'c') || (*(c_name-2) == 'C'))
    strcpy(pdf_name-2,suffix_c_pdf);
  else
    strcpy(pdf_name-3,suffix_h_pdf);
}

/*
void c_name_to_pdf_doc_name(char *c_name,char *pdf_name)
{
  while(*pdf_name++ = *c_name++)
    ;

  if((*(c_name-2) == 'c') || (*(c_name-2) == 'C'))
    strcpy(pdf_name-2,suffix_c_doc_pdf);
  else
    strcpy(pdf_name-3,suffix_h_doc_pdf);
}
*/

void c_name_to_pdf_src_name(char *c_name,char *pdf_name)

{

  while(*pdf_name++ = *c_name++)

    ;



  if((*(c_name-2) == 'c') || (*(c_name-2) == 'C'))

    strcpy(pdf_name-3,suffix_c_src_pdf);

  else

    strcpy(pdf_name-3,suffix_h_src_pdf);

}


void c_name_to_h_name(char *c_name,char *h_name)

{

  while(*h_name++ = *c_name++)

    ;

  if((*(c_name-2) == 'c') || (*(c_name-2) == 'C'))

    strcpy(h_name-3,suffix_h);

}


void Init_Param(Param *Pt)
{
  int i;

  Pt->winner  = -1;
  Pt->nb_true = nb_c_files;
  Pt->len_ref = 0;
  for(i=0;i<MAX_PATH_LEN;i++){
    Pt->ref[i] = '\0';
    Pt->file_viewer[i] = '\0';
    Pt->winner_name[i] = '\0';
    Pt->maj[i] = 0;
  }
}
void store_char(Param *Pt, char c)
{
  Pt->ref[Pt->len_ref]=tolower(c);
  Pt->maj[Pt->len_ref]=isupper(c);
  (Pt->len_ref)++;
}

void treat_c_file(FILE *f_c, FILE *f_tex,int num_file)
{
  char c;
  int i,j;
  Param pt;
  char dummy[MAX_PATH_LEN];


  c='\0';
  Init_Param(&pt);
  for(i=0;i<nb_c_files;i++)
    list_c_files[i]->char_match= 0;

  while (c != EOF){
    c = getchar_n(f_c,f_tex);

    store_char(&pt,c);

    if(pt.len_ref-1 <= MAX_PATH_LEN)
      for(i=0;i<nb_c_files;i++)
        if(list_c_files[i]->char_match == pt.len_ref-1)
          if( ((list_c_files[i]->name)[pt.len_ref-1]
               == pt.ref[pt.len_ref-1])
              && (strcmp(pt.winner_name,list_c_files[i]->name) != 0)){
            pt.winner=i;
            strcpy(pt.winner_name,list_c_files[i]->name);
            list_c_files[i]->char_match+=1;
          } else
            (pt.nb_true)--;

    strncpy(pt.winner_name,"",MAX_PATH_LEN);

    if (pt.nb_true <= 0)
      {
        if(pt.len_ref > 2)
					{
            for(i=0;i<nb_c_files;i++)
							{
                Init_File_Name(dummy);
                strncpy(dummy,pt.ref,strlen(pt.ref)-1);
                strcat(dummy,".c");
                if((strcmp(list_c_files[i]->name,dummy) == 0)
									 && (list_c_files[i]->type<=2))
									{
                    c_name_to_pdf_doc_name(list_c_files[i]->name,
																					 pt.file_viewer);
                    fprintf(f_tex,"\\href{file:%s}{",pt.file_viewer);
                    for(j=0;j<(int)strlen(pt.ref)-1;j++)
											fputc_tex(pt.ref[j],pt.maj[j],f_tex);
                    fprintf(f_tex,"}");
                    for(j=strlen(pt.ref)-1;j<(int)strlen(pt.ref);j++)
											fputc_tex(pt.ref[j],pt.maj[j],f_tex);
                    break;
									}
							}
            if(i==nb_c_files)
							for(j=0;j<(int)strlen(pt.ref);j++)
								fputc_tex(pt.ref[j],pt.maj[j],f_tex);

					}
        else {
					for(j=0;j<(int)strlen(pt.ref);j++)
						fputc_tex(pt.ref[j],pt.maj[j],f_tex);
        }
        for(i=0;i<nb_c_files;i++)
					list_c_files[i]->char_match= 0;

        Init_Param(&pt);

        continue;
      }

    if((pt.nb_true ==1) && (list_c_files[pt.winner]->char_match>=
														(int)strlen(list_c_files[pt.winner]->name) - 2))
      {
        if (list_c_files[pt.winner]->char_match ==
            (int)strlen(list_c_files[pt.winner]->name) - 2)
          {
            c = getchar_n(f_c,f_tex);
            store_char(&pt,c);


            c = getchar_n(f_c,f_tex);
            store_char(&pt,c);

          }


        if( pt.ref[strlen(pt.ref)-2] == '.')
          {

            for(i=0;i<list_c_files[num_file]->level;i++)
              if(i == 0)
                strcpy(pt.file_viewer,level_up);
              else
                dir_cat(pt.file_viewer,level_up);


            dir_cat(pt.file_viewer,list_c_files[pt.winner]->path);
            dir_cat(pt.file_viewer,list_c_files[pt.winner]->name);
            c_name_to_pdf_src_name(pt.file_viewer,pt.file_viewer);
            fprintf(f_tex,"\\href{file:%s}{%s}",pt.file_viewer,
                    list_c_files[pt.winner]->name);
            for(j=strlen(list_c_files[pt.winner]->name)+1;j<(int)strlen(pt.ref)
									;j++)
              fputc_tex(pt.ref[j],pt.maj[j],f_tex);

            for(i=0;i<nb_c_files;i++)
              list_c_files[i]->char_match = 0;
            Init_Param(&pt);

          } else {

            if((!strequ(list_c_files[num_file]->name,
                        list_c_files[pt.winner]->name))
               && (list_c_files[num_file]->type == 0)){
              create_pdf_link(list_c_files[pt.winner]->path,
                              list_c_files[pt.winner]->name,
                              list_c_files[num_file]->level,pt.file_viewer,0);
              fprintf(f_tex,"\\href{file:%s}{",pt.file_viewer);
              for(j=0;j<(int)strlen(pt.ref)-2;j++)
                fputc_tex(pt.ref[j],pt.maj[j],f_tex);
              fprintf(f_tex,"}");
              for(j=strlen(pt.ref)-2;j<(int)strlen(pt.ref);j++)
                fputc_tex(pt.ref[j],pt.maj[j],f_tex);


            } else {

              c_name_to_pdf_doc_name(list_c_files[pt.winner]->name,
                                     pt.file_viewer);
              fprintf(f_tex,"\\href{file:%s}{",pt.file_viewer);
              for(j=0;j<(int)strlen(pt.ref)-2;j++)
                fputc_tex(pt.ref[j],pt.maj[j],f_tex);
              fprintf(f_tex,"}");
              for(j=strlen(pt.ref)-2;j<(int)strlen(pt.ref);j++)
                fputc_tex(pt.ref[j],pt.maj[j],f_tex);

            }

            for(i=0;i<nb_c_files;i++)
              list_c_files[i]->char_match = 0;
            Init_Param(&pt);
          }
      }
  }
}


void begin_tex_file(FILE *f_tex,char *file_doc)
{
  fprintf(f_tex,"\\documentclass[12pt,a4paper]{article}\n");
  fprintf(f_tex,"\\input premiamble\n");
  fprintf(f_tex,"\\begin{document}\n");
  fprintf(f_tex,"\\begin{alltt}\n");
  fprintf(f_tex,"   \\href{%s}{Help}\n",file_doc);
}

void end_tex_file(FILE *f_tex)
{
  if (column == 0)
    fprintf(f_tex,"\\end{alltt}\n");
  else
    fprintf(f_tex,"\n\\end{alltt}\n");

  fprintf(f_tex,"\\input premiaend\n");
  fprintf(f_tex,"\\end{document}\n");
}



int c_to_latex (char *path_abs,int num_file)
{
  char  path_tex[MAX_PATH_LEN]="",path_c[MAX_PATH_LEN]="",path_doc[MAX_PATH_LEN]="";
  FILE *file_c,*file_tex;
	int i;
	
  if(strlen(path_abs) + strlen(list_c_files[num_file]->path)
     + strlen(list_c_files[num_file]->name) + 3 > MAX_PATH_LEN)
    error(2,list_c_files[num_file]->name);
  dir_cpy(path_abs,list_c_files[num_file]->path,path_c);
  dir_cat(path_c,list_c_files[num_file]->name);


	if(strlen(path_abs) + strlen(list_c_files[num_file]->path)
     + strlen(list_c_files[num_file]->name) + 12 > MAX_PATH_LEN )
    error(2,list_c_files[num_file]->name);
  c_name_to_tex_name(path_c,path_tex);

  if(strlen(list_c_files[num_file]->name) + 11  > MAX_PATH_LEN )
    error(2,list_c_files[num_file]->name);
  c_name_to_pdf_doc_name(list_c_files[num_file]->name,path_doc);

  if ((file_c = fopen(path_c, "r")) == NULL)
    error(4, path_c);

  if ((file_tex = fopen(path_tex, "w")) == NULL)
    error(5, path_tex);

  lineno=1;
  column=1;

  files_proc++;
  fprintf(stdout,"file %d on %d %s\n",files_proc,nb_c_files,
					list_c_files[num_file]->name);
  fprintf(stdout,"         creating %s...\n",path_tex);

	
  begin_tex_file(file_tex,path_doc);

  treat_c_file(file_c,file_tex,num_file);

  end_tex_file(file_tex);

  fclose(file_tex);
  fclose(file_c);

  return 1;
}

#ifdef DIR_OPT
void scan_dir(char *dir_abs)
{
  DIR *dirp;
  dir_type *dp;
  char current_dir[MAX_PATH_LEN];
  char test;

  dirp = opendir(dir_abs);
  if (dirp == NULL)
    error(3,dir_abs);
  while ( (dp = readdir(dirp)) != NULL ) {
    Init_File_Name(current_dir);

    if (strequ(dp->d_name,".") || strequ(dp->d_name,".."))
      continue;

    if(strlen(dir_abs) + NLENGTH(dp) + 2 > MAX_PATH_LEN)
      error(2,dp->d_name);
    dir_cpy(dir_abs,dp->d_name,current_dir);

    if( opendir(current_dir) != NULL){
      printf("\nTreat the repertory %s (y/n) ? ",current_dir);
      test = getchar();
      getchar();
      if (test == 'y')
        treat_dir(dir_abs,dp->d_name);
    }
  }
}
#endif
#ifdef _WIN32
void scan_dir(char *dir_abs)
{
  struct _finddata_t direct;
  char BUFFER[MAX_PATH_LEN];
  long d;

  char current_dir[MAX_PATH_LEN];

  int test;


  _getcwd(BUFFER,MAX_PATH_LEN);
  if(_chdir(dir_abs))
    error(3,dir_abs);
  else {
    if( (d = _findfirst("*",&direct)) == -1L)
      error(6,dir_abs);
    else {
      Init_File_Name(current_dir);
      if(strlen(dir_abs) + strlen(direct.name) + 2 > _MAX_PATH)
        error(2,direct.name);
      dir_cpy(dir_abs,direct.name,current_dir);
      if(direct.attrib == _A_SUBDIR)
        if((!strequ(direct.name,".")) && (!strequ(direct.name,".."))) {
          printf("Treat the directory %s ?\n",current_dir);
          test = getchar();
          getchar();
        }

      while(_findnext(d,&direct) == 0) {
        if((strequ(direct.name,".")) || (strequ(direct.name,"..")))
          continue;
        Init_File_Name(current_dir);
        if(strlen(dir_abs) + strlen(direct.name) + 2 > _MAX_PATH)
          error(2,direct.name);
        dir_cpy(dir_abs,direct.name,current_dir);
        if(direct.attrib == _A_SUBDIR) {
          printf("Treat the directory %s ?\n",direct.name);
          test = getchar();
          getchar();
          if (test == 'y') {
            strcpy(path_win,direct.name);
            treat_dir(direct.name);
            Init_File_Name(path_win);
          }
        }
      }
      _findclose(d);
    }
  }

  _chdir(BUFFER);

}
#endif

int create_file_doc(char *dir_abs,char *path,char *name)
{
  char f[MAX_PATH_LEN],fl[MAX_PATH_LEN];
  FILE *fp;

  Init_File_Name(f);
  Init_File_Name(fl);
  if(strlen(dir_abs) + strlen(path) + strlen(name)
     + 2 > MAX_PATH_LEN)
    error(2,name);
  dir_cpy(dir_abs,path,f);
  dir_cat(f,name);
  strcpy(fl,name);
  c_name_to_tex_doc_name(f,f);
  c_name_to_tex_docl_name(fl,fl);

  if ((fp = fopen(f,"r")) != NULL){
    fprintf(stderr,"Warning: The file %s seems to exist.\n",f);
    fprintf(stderr,"         If not, create it manually\n");
    fclose(fp);
    return 0;
  } else {
    if ((fp = fopen(f,"w")) == NULL)
      error(5,f);

    
    fprintf(fp,"\\documentclass[12pt,a4paper]{article}\n");
		fprintf(fp,"\\input premiamble\n");

    fprintf(fp,"\\begin{document}\n");
    fprintf(fp,"\\input{%s}\n",fl);

    fprintf(fp,"\\input premiaend\n");
    fprintf(fp,"\\end{document}\n");
    fclose(fp);
  }
}

int create_file_nobib_dir_doc(char *dir_abs,char *path,char *name)
{
  char f[MAX_PATH_LEN],fl[MAX_PATH_LEN];
  FILE *fp;


  Init_File_Name(f);
  Init_File_Name(fl);
  if(strlen(dir_abs) + strlen(path) + strlen(name)
     + 2 > MAX_PATH_LEN)
    error(2,name);
  dir_cpy(dir_abs,path,f);
  dir_cat(f,name);
  strcpy(fl,name);
  c_name_to_tex_doc_name(f,f);
  c_name_to_tex_docl_name(fl,fl);

  if ((fp = fopen(f,"r")) != NULL){
    fprintf(stderr,"Warning: The file %s seems to exist.\n",f);
    fprintf(stderr,"         If not, create it manually\n");
    fclose(fp);
    return 0;
  } else {
    if ((fp = fopen(f,"w")) == NULL)
      error(5,f);

    
    fprintf(fp,"\\documentclass[12pt,a4paper]{article}\n");
		fprintf(fp,"\\input premiamble\n");
		fprintf(fp,"\\input premiadata\n");

    fprintf(fp,"\\begin{document}\n");
    fprintf(fp,"\\input{%s}\n",fl);

    fprintf(fp,"\\input premiaendnobib\n");
    fprintf(fp,"\\end{document}\n");
    fclose(fp);
  }
}



int create_file_nobib_master_doc(char *dir_abs,char *path,char *name)
{
  char f[MAX_PATH_LEN],fl[MAX_PATH_LEN],fh[MAX_PATH_LEN];
  FILE *fp;


  Init_File_Name(f);
  Init_File_Name(fl);
  if(strlen(dir_abs) + strlen(path) + strlen(name)
     + 2 > MAX_PATH_LEN)
    error(2,name);
  dir_cpy(dir_abs,path,f);
  dir_cat(f,name);
  strcpy(fl,name);

  c_name_to_tex_doc_name(f,f);
  c_name_to_tex_docl_name(fl,fl);
  c_name_to_h_name(name,fh);


  if ((fp = fopen(f,"r")) != NULL){
    fprintf(stderr,"Warning: The file %s seems to exist.\n",f);
    fprintf(stderr,"         If not, create it manually\n");
    fclose(fp);
    return 0;
  } else {
    if ((fp = fopen(f,"w")) == NULL)
      error(5,f);

    
    fprintf(fp,"\\documentclass[12pt,a4paper]{article}\n");
		fprintf(fp,"\\input premiamble\n");
		fprintf(fp,"\\input premiadata\n");

    fprintf(fp,"\\begin{document}\n");
    fprintf(fp,"\\input{%s}\n",fl);

		fprintf(fp,"\\section{Description}\n");

		fprintf(fp,"\\section{Code Implementation}\n");


		fprintf(fp,"\\verbatiminput{%s}\n",fh);

    fprintf(fp,"\\input premiaendnobib\n");
    fprintf(fp,"\\end{document}\n");
    fclose(fp);
  }
}


void summury_open(char *dir_abs)
{
  char cur_dir[MAX_PATH_LEN];


  Init_File_Name(cur_dir);
  if (strlen(dir_abs) > MAX_PATH_LEN)
    error(2,dir_abs);

  if(strlen(dir_abs) + strlen(summury_file) +2 > MAX_PATH_LEN)
    error(2,summury_file);
  dir_cpy(dir_abs,summury_file,cur_dir);

  if ((summury = fopen(cur_dir,"w")) == NULL)
    error(5,cur_dir);

  
  fprintf(summury,"\\documentclass[12pt,a4paper]{article}\n");
  fprintf(summury,"\\input premiamble\n");
  fprintf(summury,"\\input premiadata\n");

  fprintf(summury,"\\begin{document}\n");
  fprintf(summury,"\\begin{alltt}\n");
  fclose(summury);

}

void summury_close(char *dir_abs)
{
  char cur_dir[MAX_PATH_LEN];


  Init_File_Name(cur_dir);
  if (strlen(dir_abs) > MAX_PATH_LEN)
    error(2,dir_abs);

  if(strlen(dir_abs) + strlen(summury_file) +2 > MAX_PATH_LEN)
    error(2,summury_file);
  dir_cpy(dir_abs,summury_file,cur_dir);

  if ((summury = fopen(cur_dir,"a")) == NULL)
    error(5,cur_dir);

  fprintf(summury,"\\end{alltt}\n");
  fprintf(summury,"\\input premiaendnobib\n");
  fprintf(summury,"\\end{document}\n");
  fclose(summury);

}

void create_pdf_link(char *path,char *name,int nb_level,
                     char pdf_link[MAX_PATH_LEN],int flag)
{
  int j;

  if(strlen(level_up)*nb_level +  strlen(path) +
     strlen(name) + 6 > MAX_PATH_LEN )
    error(2,name);
  for(j=0;j<nb_level;j++)
    if(j == 0)
      strcpy(pdf_link,level_up);
    else
      dir_cat(pdf_link,level_up);
  if(nb_level == 0)
    dir_cpy(path,name,pdf_link);
  else{
    dir_cat(pdf_link,path);
    dir_cat(pdf_link,name);
  }
  if(flag == 1)
    c_name_to_pdf_doc_name(pdf_link,pdf_link);

  else

    c_name_to_pdf_src_name(pdf_link,pdf_link);
}

void summury_add(char *dir_abs,int i)
{
  char cur_dir[MAX_PATH_LEN],pdf_link[MAX_PATH_LEN];


  Init_File_Name(cur_dir);

  Init_File_Name(pdf_link);
  if (strlen(dir_abs) > MAX_PATH_LEN)
    error(2,dir_abs);

  if(strlen(dir_abs) + strlen(summury_file) +2 > MAX_PATH_LEN)
    error(2,summury_file);
  dir_cpy(dir_abs,summury_file,cur_dir);

  if ((summury = fopen(cur_dir,"a")) == NULL)
    error(5,cur_dir);

  create_pdf_link(list_c_files[i]->path,list_c_files[i]->name,0,pdf_link,0);

  if ((i==0)||!(strcmp(list_c_files[i-1]->path,list_c_files[i]->path)==0))
    fprintf(summury,"\n\\dir{%s}\n",list_c_files[i]->path);	/*CM*/

  fprintf(summury,"%s : \\href{%s}{%s}\n",list_c_files[i]->path,
          pdf_link,list_c_files[i]->name);
  fclose(summury);

}



void routine_link(int i,char *dir_abs)
{
  char mod_file[MAX_PATH_LEN]="",opt_file[MAX_PATH_LEN]="",src_file[MAX_PATH_LEN]="",*dummy_ptr;
  char files_doc[MAX_PATH_LEN]="",mod_opt_file[MAX_PATH_LEN]="";
  char rout_type[MAX_PATH_LEN]="",tmp[MAX_PATH_LEN]="",fplain[MAX_PATH_LEN]="";
  FILE *doc;
  int mod=0;
  int opt=0;
  int mod_opt=0;

  char *pdest;
  int result;

  pdest = strchr(list_c_files[i]->name,'.');   
  result = pdest - list_c_files[i]->name;

  strncpy(fplain,list_c_files[i]->name,result);

  printf("\n%s\n",fplain);


  if(strlen(dir_abs) + strlen(list_c_files[i]->path)
     + strlen(list_c_files[i]->name)
     + 10 > MAX_PATH_LEN )
    error(2,list_c_files[i]->name);
  dir_cpy(dir_abs,list_c_files[i]->path,files_doc);
  dir_cat(files_doc,list_c_files[i]->name);

  create_file_doc(dir_abs,list_c_files[i]->path,list_c_files[i]->name);

  c_name_to_tex_docl_name(files_doc,files_doc);
  if((doc = fopen(files_doc,"w")) == NULL)
    error(2,files_doc);

  find_mod_opt(i,&mod,&opt,&mod_opt);

  create_pdf_link(list_c_files[mod]->path,list_c_files[mod]->name,
                  list_c_files[i]->level,mod_file,1);
  create_pdf_link(list_c_files[opt]->path,list_c_files[opt]->name,
                  list_c_files[i]->level,opt_file,1);
  create_pdf_link(list_c_files[mod_opt]->path,list_c_files[mod_opt]->name,
                  list_c_files[i]->level,mod_opt_file,1);
  strcpy(tmp,type_algo[list_c_files[i]->routine]);
  strcat(tmp,".c");
  create_pdf_link("",tmp,list_c_files[i]->level,rout_type,1);

  strcpy(src_file,list_c_files[i]->name);
  c_name_to_pdf_src_name(src_file,src_file);

  fprintf(doc,"\n\\begin{alltt}\n");
  fprintf(doc,"   \\href{%s}{Source}  |  \\href{%s}{Model}  |  \\href{%s}{Option} \n  |  \\href{%s}{Model_Option} |   \\href{%s}{Help on %s methods}", src_file,mod_file,opt_file,mod_opt_file,rout_type,type_algo[list_c_files[i]->routine]);

  strcpy(tmp,list_c_files[i]->name);
  dummy_ptr=strrchr(tmp,'.');
  *dummy_ptr='\0';
  strcat(tmp,"_testl.pdf");
  fprintf(doc," |   \\href{%s}{Archived Tests}\n", tmp);

  fprintf(doc,"\n\\begin{center}\n");
  fprintf(doc,"\n\\textcolor{red}{\\BF\\Huge %s}\n",fplain);
  fprintf(doc,"\n\\end{center}\n");

  fprintf(doc,"\\end{alltt}\n");


  fclose(doc);
}

void test_link(int i,char *dir_abs)
{
  char mod_file[MAX_PATH_LEN]="",opt_file[MAX_PATH_LEN]="",src_file[MAX_PATH_LEN]="",*dummy_ptr;
  char files_doc[MAX_PATH_LEN]="",mod_opt_file[MAX_PATH_LEN]="";
  char rout_type[MAX_PATH_LEN]="",tmp[MAX_PATH_LEN]="",fplain[MAX_PATH_LEN]="";
  FILE *doc;
  int mod=0;
  int opt=0;
  int mod_opt=0;

  char *pdest;
  int result;

  pdest = strchr(list_c_files[i]->name,'.');   
  result = pdest - list_c_files[i]->name;

  strncpy(fplain,list_c_files[i]->name,result);

  printf("\n%s\n",fplain);

  if(strlen(dir_abs) + strlen(list_c_files[i]->path)
     + strlen(list_c_files[i]->name)
     + 10 > MAX_PATH_LEN )
    error(2,list_c_files[i]->name);
  dir_cpy(dir_abs,list_c_files[i]->path,files_doc);
  dir_cat(files_doc,list_c_files[i]->name);

  create_file_nobib_dir_doc(dir_abs,list_c_files[i]->path,list_c_files[i]->name);

  c_name_to_tex_docl_name(files_doc,files_doc);
  if((doc = fopen(files_doc,"w")) == NULL)
    error(2,files_doc);

  find_mod_opt(i,&mod,&opt,&mod_opt);

  create_pdf_link(list_c_files[mod]->path,list_c_files[mod]->name,
                  list_c_files[i]->level,mod_file,1);
  create_pdf_link(list_c_files[opt]->path,list_c_files[opt]->name,
                  list_c_files[i]->level,opt_file,1);
  create_pdf_link(list_c_files[mod_opt]->path,list_c_files[mod_opt]->name,
                  list_c_files[i]->level,mod_opt_file,1);
  strcpy(tmp,type_algo[list_c_files[i]->routine]);
  strcat(tmp,".c");
  create_pdf_link("",tmp,list_c_files[i]->level,rout_type,1);

  strcpy(src_file,list_c_files[i]->name);
  c_name_to_pdf_src_name(src_file,src_file);

  fprintf(doc,"\n\\begin{alltt}\n");
  fprintf(doc,"   \\href{%s}{Source}  |  \\href{%s}{Model}  |  \\href{%s}{Option Family} \n  |  \\href{%s}{Model_Option}" , src_file,mod_file,opt_file,mod_opt_file);

  strcpy(tmp,list_c_files[i]->name);
  dummy_ptr=strrchr(tmp,'.');
  *dummy_ptr='\0';
  strcat(tmp,"_testl.pdf");
  fprintf(doc," |   \\href{%s}{Archived Dyn Tests}\n", tmp);

  fprintf(doc,"\n\\begin{center}\n");
  fprintf(doc,"\n\\textcolor{red}{\\BF\\Huge %s}\n",fplain);
  fprintf(doc,"\n\\end{center}\n");

  fprintf(doc,"\\end{alltt}\n");


  fclose(doc);
}

void mod_link(int i,char *dir_abs)
{
  char mod_file[MAX_PATH_LEN]="";
  char files_doc[MAX_PATH_LEN]="",src_file[MAX_PATH_LEN]="",fplain[MAX_PATH_LEN]="",fmaster[MAX_PATH_LEN]="";
  FILE *doc;
  int j;
  int charac='/';

  if(strlen(dir_abs) + strlen(list_c_files[i]->path)
     + strlen(list_c_files[i]->name)
     + 10 > MAX_PATH_LEN )
    error(2,list_c_files[i]->name);
  dir_cpy(dir_abs,list_c_files[i]->path,files_doc);
  dir_cat(files_doc,list_c_files[i]->name);

  strcpy(fplain,strrchr(list_c_files[i]->path,charac)+1);
  strcpy(fmaster,strrchr(list_c_files[i]->path,charac)+1);			
  strcat(fmaster,".c");

  if (strcmp(fmaster,list_c_files[i]->name)==0)
		{
			create_file_nobib_master_doc(dir_abs,list_c_files[i]->path,list_c_files[i]->name);
		}
  else
    create_file_doc(dir_abs,list_c_files[i]->path,list_c_files[i]->name);

  c_name_to_tex_docl_name(files_doc,files_doc);
  if((doc = fopen(files_doc,"w")) == NULL)
    error(2,files_doc);


  strcpy(src_file,list_c_files[i]->name);
  c_name_to_pdf_src_name(src_file,src_file);

  for(j=0;j<list_c_files[i]->level;j++)
    if(j == 0)
      strcpy(mod_file,level_up);
    else
      dir_cat(mod_file,level_up);
  dir_cat(mod_file,mod_f);
  strcat(mod_file,suffix_c_doc_pdf);

  fprintf(doc,"\n\\begin{alltt}\n");
  fprintf(doc,"   \\href{%s}{Source}  |  \\href{%s}{Model Presentation}\n",src_file,mod_file);
  if (strcmp(fmaster,list_c_files[i]->name)==0)
		{
			fprintf(doc,"\n\\begin{center}\n");
			fprintf(doc,"\n\\textcolor{red}{\\BF\\Huge %s}\n",fplain);
			fprintf(doc,"\n\\end{center}\n");
		}


  fprintf(doc,"\\end{alltt}\n");
  fclose(doc);
}


void opt_link(int i,char *dir_abs)
{
  char opt_file[MAX_PATH_LEN]="",src_file[MAX_PATH_LEN]="",fplain[MAX_PATH_LEN]="",fmaster[MAX_PATH_LEN]="";
  char files_doc[MAX_PATH_LEN]="",link[MAX_PATH_LEN]="";
  FILE *doc;
  int j;
  int charac='/';
  
  char *pdest;
  int result;

  pdest = strchr(list_c_files[i]->name,'.');   
  result = pdest - list_c_files[i]->name;

  strncpy(fplain,list_c_files[i]->name,result);

  printf("\n%s\n",fplain);


  if(strlen(dir_abs) + strlen(list_c_files[i]->path)
     + strlen(list_c_files[i]->name)
     + 10 > MAX_PATH_LEN )
    error(2,list_c_files[i]->name);
  dir_cpy(dir_abs,list_c_files[i]->path,files_doc);
  dir_cat(files_doc,list_c_files[i]->name);

  strcpy(fmaster,strrchr(list_c_files[i]->path,charac)+1);			
  strcat(fmaster,".c");

  if (strcmp(fmaster,list_c_files[i]->name)==0)
		{
			create_file_nobib_master_doc(dir_abs,list_c_files[i]->path,list_c_files[i]->name);
		}
  else
		create_file_doc(dir_abs,list_c_files[i]->path,list_c_files[i]->name);

  c_name_to_tex_docl_name(files_doc,files_doc);
  if((doc = fopen(files_doc,"w")) == NULL)
    error(2,files_doc);


  strcpy(src_file,list_c_files[i]->name);
  c_name_to_pdf_src_name(src_file,src_file);

  c_name_to_pdf_doc_name(fmaster,fmaster);

  /*for(j=0;j<list_c_files[i]->level;j++)
    if(j == 0)
		strcpy(opt_file,level_up);
    else
		dir_cat(opt_file,level_up);
		dir_cat(opt_file,opt_f);*/

  strcat(opt_file,suffix_c_doc_pdf);

  fprintf(doc,"\n\\begin{alltt}\n");
  fprintf(doc,"   \\href{%s}{Source}  |  \\href{%s}{Option Family}",src_file,fmaster);

  fprintf(doc,"\n\\begin{center}\n");
  fprintf(doc,"\n\\textcolor{red}{\\BF\\Huge %s}\n",fplain);
  fprintf(doc,"\n\\end{center}\n");

	if (strcmp(fmaster,list_c_files[i]->name)==0)
		{
 
			for(j=0;j<nb_c_files;j++)
				if ((strcmp(list_c_files[i]->path,list_c_files[j]->path)==0) && (list_c_files[j]->type==2))
					{
						if (strcmp(list_c_files[i]->name,list_c_files[j]->name)!=0)
							{
								/* create_pdf_link(list_c_files[i]->path,list_c_files[j]->name,0,link,1);*/
								printf("%s\t",list_c_files[j]->name);

								strcpy(link,list_c_files[j]->name);
								c_name_to_pdf_src_name(link,link);

			
								/*strcpy(link," ");
									strncpy(link,list_c_files[j]->name,strcspn(list_c_files[j]->name,"."));
									strcat(link,"_src.pdf");*/

								printf("%s\n",link);


								fprintf(doc,"\\href{%s}{Option %s}\n",link,list_c_files[j]->name);
							}
					}



		}

  fprintf(doc,"\\end{alltt}\n");
  fclose(doc);
}



void mod_opt_link(int i,char *dir_abs)
{
  char mod_file[MAX_PATH_LEN]="",opt_file[MAX_PATH_LEN]="",src_file[MAX_PATH_LEN]="", test_file[MAX_PATH_LEN]="",plain_file[MAX_PATH_LEN]="",tmp[MAX_PATH_LEN]="";
  char files_doc[MAX_PATH_LEN]="";
  char link[MAX_PATH_LEN]="";
  char *dummy_ptr;
  FILE *doc;
  int mod=0;
  int opt=0;
  int mod_opt=0;
  int j;


  if(strlen(dir_abs) + strlen(list_c_files[i]->path)
     + strlen(list_c_files[i]->name)
     + 10 > MAX_PATH_LEN )
    error(2,list_c_files[i]->name);
  dir_cpy(dir_abs,list_c_files[i]->path,files_doc);
  dir_cat(files_doc,list_c_files[i]->name);
  create_file_nobib_dir_doc(dir_abs,list_c_files[i]->path,list_c_files[i]->name);
  c_name_to_tex_docl_name(files_doc,files_doc);
  if((doc = fopen(files_doc,"w")) == NULL)
    error(2,files_doc);

  find_mod_opt(i,&mod,&opt,&mod_opt);

  create_pdf_link(list_c_files[mod]->path,list_c_files[mod]->name,
                  list_c_files[i]->level,mod_file,1);

  create_pdf_link(list_c_files[opt]->path,list_c_files[opt]->name,
                  list_c_files[i]->level,opt_file,1);


  strcpy(src_file,list_c_files[i]->name);
  c_name_to_pdf_src_name(src_file,src_file);

  strncpy(test_file,list_c_files[i]->name,strcspn(list_c_files[i]->name,"."));
  strcpy(plain_file,test_file);
  strcat(test_file,"_test_doc.pdf");

  fprintf(doc,"\n\\begin{alltt}\n");
  fprintf(doc,"   \\href{%s}{Source}  |  \\href{%s}{Model}  |  \\href{%s}{Option Family} |  \\href{%s}{Dyn Hedge} \n",src_file,mod_file,opt_file,test_file);

  /*fprintf(doc,"\\end{alltt}\n");*/
  strcpy(tmp,list_c_files[i]->name);
  dummy_ptr=strrchr(tmp,'.');
  *dummy_ptr='\0';
  strcat(tmp,"_testl.pdf");
  fprintf(doc," |   \\href{%s}{Archived Comp Tests}\n", tmp);


  fprintf(doc,"\n\\begin{center}\n");
  fprintf(doc,"\n\\textcolor{red}{\\BF\\Huge %s}\n",plain_file);
  fprintf(doc,"\n\\end{center}\n");


	/* fprintf(doc,"\n\\begin{alltt}\n");*/
  
  for(j=0;j<nb_c_files;j++)
		if ((strcmp(list_c_files[i]->path,list_c_files[j]->path)==0) && (list_c_files[j]->type==0))
			{
				if ((strcmp(list_c_files[i]->name,list_c_files[j]->name)!=0) && (strcmp(test_file,list_c_files[j]->name)!=0))
					{
						/* create_pdf_link(list_c_files[i]->path,list_c_files[j]->name,0,link,1);*/
						printf("%s\t",list_c_files[j]->name);

						strcpy(link,list_c_files[j]->name);
						c_name_to_pdf_src_name(link,link);

			
						/*strcpy(link," ");
							strncpy(link,list_c_files[j]->name,strcspn(list_c_files[j]->name,"."));
							strcat(link,"_src.pdf");*/

						printf("%s\n",link);


						fprintf(doc,"   \\href{%s}{%s}\n",link,list_c_files[j]->name);
					}
			}
 
  fprintf(doc,"\\end{alltt}\n");
  


  fclose(doc);
}



void edit_mod_file(char *dir_abs)
{
  FILE *fp;
  char f[MAX_PATH_LEN],link[MAX_PATH_LEN];
  int i,j,lasti;

  Init_File_Name(f);

  Init_File_Name(link);
  strcpy(f,mod_f);
  strcat(f,".c");

  create_file_nobib_dir_doc(dir_abs,"",f);
  dir_cpy(dir_abs,f,link);
  strcpy(f,link);
  Init_File_Name(link);

  c_name_to_tex_docl_name(f,f);
  if((fp = fopen(f,"w")) == NULL)
    error(2,f);
  fprintf(fp,"\\begin{alltt}\n");

  j=0;
  for(i=0;i<nb_c_files;i++)
    if(list_c_files[i]->type == 1)
			{
				if ((j==0)||!(strcmp(list_c_files[lasti]->path,list_c_files[i]->path)==0))
					fprintf(fp,"\n\\dir{%s}\n",list_c_files[i]->path);	/*CM*/
	 
				create_pdf_link(list_c_files[i]->path,list_c_files[i]->name,0,link,1);
				fprintf(fp,"   \\href{%s}{Model %s}\n",link,list_c_files[i]->name);

				lasti=i;
				j++;
			}
 
  fprintf(fp,"\\end{alltt}\n");
  fclose(fp);
}



void edit_opt_file(char *dir_abs)
{
  FILE *fp;
  char f[MAX_PATH_LEN],link[MAX_PATH_LEN],fmaster[MAX_PATH_LEN],fplain[MAX_PATH_LEN];
  int i,j,lasti,k,notfound;
  int charac='/';

  Init_File_Name(f);

  Init_File_Name(link);
  strcpy(f,opt_f);
  strcat(f,".c");

  create_file_nobib_dir_doc(dir_abs,"",f);
  dir_cpy(dir_abs,f,link);
  strcpy(f,link);
  Init_File_Name(link);

  c_name_to_tex_docl_name(f,f);
  if((fp = fopen(f,"w")) == NULL)
    error(2,f);
  fprintf(fp,"\\begin{alltt}\n");

  j=0;
  for(i=0;i<nb_c_files;i++)
    if(list_c_files[i]->type == 2)
			{
				if ((j==0)||!(strcmp(list_c_files[lasti]->path,list_c_files[i]->path)==0))
					{
						strcpy(fplain,strrchr(list_c_files[i]->path,charac)+1);
						strcpy(fmaster,strrchr(list_c_files[i]->path,charac)+1);			
						strcat(fmaster,".c");

						k=0;notfound=1;
						do
							{	
								if (strcmp(fmaster,list_c_files[k]->name)==0)
									{
										notfound=0;
									}
								else k++;
							}
						while (notfound);				
			
						create_pdf_link(list_c_files[i]->path,list_c_files[k]->name,0,link,1);
						fprintf(fp,"\n\\dir{Family }\t\\href{%s}{%s}\n",link,fplain);
					
					}/*CM*/
			
				if (!(strcmp(fmaster,list_c_files[i]->name)==0))
					{
						create_pdf_link(list_c_files[i]->path,list_c_files[i]->name,0,link,1);
						fprintf(fp,"   \\href{%s}{Option %s}\n",link,list_c_files[i]->name);
					}

				lasti=i;
				j++;
			}


  fprintf(fp,"\\end{alltt}\n");
  fclose(fp);
}



void edit_alg_file(char *dir_abs,int i)
{
  FILE *fp;
  char f[MAX_PATH_LEN],link[MAX_PATH_LEN];
  int j;

  Init_File_Name(f);
  Init_File_Name(link);
  strcpy(f,type_algo[i]);
  strcat(f,".c");

  create_file_doc(dir_abs,"",f);

  dir_cpy(dir_abs,f,link);
  strcpy(f,link);
  Init_File_Name(link);
  c_name_to_tex_docl_name(f,f);
  if((fp = fopen(f,"w")) == NULL)
    error(2,f);
  fprintf(fp,"\\begin{alltt}\n");
  for(j=0;j<nb_c_files;j++)
    if((list_c_files[j]->type == 0) && (list_c_files[j]->routine == i)) 
			{
				create_pdf_link(list_c_files[j]->path,list_c_files[j]->name,0,link,1);
				fprintf(fp,"   \\href{%s}{Routine %s}\n",link,list_c_files[j]->name);
			}
  fprintf(fp,"\\end{alltt}\n");
  fclose(fp);
}


int main(int argc,char *argv[])
{
  int i;
  FILE *doc;
  char files_doc[MAX_PATH_LEN]="";
  char src_file[MAX_PATH_LEN]="";

	if((premiasrcdir=getenv("PREMIADIR")) == NULL)
		error(8,"");
		
	

  strcat(premiasrcdir,path_sep);
	strcat(premiasrcdir,"Src");
	

  switch(argc){
  case 1:
    scan_dir(premiasrcdir);
    summury_open(premiasrcdir);

    /*Creation of the links for the File mod_f in mod_docl.tex */
    edit_mod_file(premiasrcdir);
    edit_opt_file(premiasrcdir);
    for(i=0;i<MAX_TYPE;i++)
      edit_alg_file(premiasrcdir,i);

    for(i=0;i<nb_c_files;i++){

      /* Creation of the summary */
      summury_add(premiasrcdir,i);


      /* Creation of the files routine_doc.tex with the hyperlinks */
      switch(list_c_files[i]->type)
				{
				case 0:
					routine_link(i,premiasrcdir);
					break;
				case 1:
					mod_link(i,premiasrcdir);
					break;
				case 2:
					opt_link(i,premiasrcdir);
					break;
				case 3:
					mod_opt_link(i,premiasrcdir);
					break;
				case 4:
					break;

				case 5:
					test_link(i,premiasrcdir);
       
					break;
				default:
					Init_File_Name(files_doc);
					Init_File_Name(src_file);
					if(strlen(list_c_files[i]->path) +
						 strlen(list_c_files[i]->name) + 10 > MAX_PATH_LEN )
						error(2,list_c_files[i]->name);
					dir_cpy(premiasrcdir,list_c_files[i]->path,files_doc);
					dir_cat(files_doc,list_c_files[i]->name);
					c_name_to_tex_docl_name(files_doc,files_doc);
					if((doc = fopen(files_doc,"w")) == NULL)
						error(2,files_doc);

					strcpy(src_file,list_c_files[i]->name);
					c_name_to_pdf_src_name(src_file,src_file);

					fprintf(doc,"\n\\begin{alltt}\n");
					fprintf(doc,"   \\href{%s}{Source}\n",src_file);
					fprintf(doc,"\\end{alltt}\n");
					fclose(doc);
					break;
				}


      c_to_latex(premiasrcdir,i);
    }

    summury_close(premiasrcdir);
    break;

  default:
    printf("usage: premiaCToTeX \n");
    break;
  }

  return 0;
}
