#include "bs1d_limdisc.h"

int MOD_OPT(ChkMix)(Option *Opt,Model *Mod)
{
    TYPEOPT* ptOpt=( TYPEOPT*)(Opt->TypeOpt);
    TYPEMOD* ptMod=( TYPEMOD*)(Mod->TypeModel);
    int status=OK;

    if (ptOpt->Maturity.Val.V_DATE<=ptMod->T.Val.V_DATE)
    {
        Fprintf(TOSCREENANDFILE,"Current date greater than maturity!\n");
        status+=1;
    };

    if ((ptOpt->Limit.Val.V_NUMFUNC_1)->Par[0].Val.V_DATE>=ptMod->T.Val.V_DATE)
    {
        Fprintf(TOSCREENANDFILE,"Current date lower than Starting date!\n");
        status+=1;
    };

    return status;
}

extern PricingMethod MET(AP_BroadieGlassermanKou);
extern PricingMethod MET(MC_VarianceReduction);

PricingMethod *MOD_OPT(methods)[]={
        &MET(AP_BroadieGlassermanKou),
				&MET(MC_VarianceReduction),
        NULL
    };

extern DynamicTest MOD_OPT(test);
DynamicTest* MOD_OPT(tests)[]={
		&MOD_OPT(test),
		NULL
	};

Pricing MOD_OPT(pricing)={
        ID_MOD_OPT,
        MOD_OPT(methods),
        MOD_OPT(tests),
        MOD_OPT(ChkMix)
    };
