#ifndef  _BS1D_PAD_H
#define _BS1D_PAD_H

#include "bs1d.h"
#include "pad.h"

#include "mathtools.h"
#include "random.h"
#include "transopt.h"
#include "numfunc.h"
#include "complex.h"
#include "moments.h"
/* ------------------------------------------------------------------- */
/* Analytic formula used if K'<0. */
/* ------------------------------------------------------------------- */

static int Analytic_KemnaVorst(double pseudo_stock, double pseudo_strike, double time_spent, NumFunc_2  *p, double t, double r, double divid, double *ptprice, double *ptdelta)
{
  double b;
  
  b= r-divid;

  /* Put Case */
  if ((p->Compute) == &Put_OverSpot2)
    {
      *ptprice=0.;
      *ptdelta=0.;
    }
  /* Call case */
  else
    {
      /* Case r=d */
      if(b==0.)
	{
	  *ptprice= exp(-r*t)*(pseudo_stock-pseudo_strike);
	  *ptdelta= exp(-r*t)*(1.-time_spent);
	}
      /* Case r <> d */
      else
	{
	  *ptprice= exp(-r*t)*(pseudo_stock*(1.0/(b*t))*(exp(b*t)-1)-pseudo_strike);
	  *ptdelta= exp(-r*t)*((1-time_spent)/(b*t)*(exp(b*t)-1));
	}
    }  
  return OK;
}


#endif
