#ifndef  _DUP1D_STD_H
#define _DUP1D_STD_H

#include "dup1d.h"
#include "std.h"

#include "mathtools.h"
#include "random.h"
#include "numfunc.h"
#include "transopt.h"
#include "linsys.h"
#include <float.h>

/* Local Volatility Examples Sigma(t,x) */
static double volatility(double t, double x,int sigma_type)
{
  double val;
 
  if(sigma_type==0) 
    {
      val=15./x;
    } 

  else if(sigma_type==1) 
    {
       val=0.01+0.1*exp(-x/100)+0.01*t;
    }

  if (val>=1.)  val=1.;
  else if (val<=0.01)
    val=0.01;

  return val;
}

/* First Order Derivatives Sigma(t,x) for Adaptive Method*/
static double volatility_x(double t, double x,int sigma_type)
{
  double val;


    if(sigma_type==0) 
    {
      val=-15./SQR(x);
    }
  else if(sigma_type==1) 
    {
   val=-0.1/100.*exp(-x/100.);
    }   

  return val;
}

/* Second Order Derivatives Sigma(t,x) for Adaptive Method */
static double volatility_xx(double t, double x,int sigma_type)
{
  double val;
 

    if(sigma_type==0) 
    {
      val=30./CUB(x);
    }
  else if(sigma_type==1) 
    {
      val=0.1/(100.*100.)*exp(-x/100.);
    }

  return val;
}

#endif
