#include  "mer1d_std.h" 

int MOD_OPT(ChkMix)(Option *Opt,Model *Mod)
	{
	TYPEOPT* ptOpt=( TYPEOPT*)(Opt->TypeOpt);
	TYPEMOD* ptMod=( TYPEMOD*)(Mod->TypeModel);
	int status=OK;
	
    if ((ptOpt->Maturity.Val.V_DATE)<=(ptMod->T.Val.V_DATE))
		{
		Fprintf(TOSCREENANDFILE,"Current date greater than maturity!\n");
		status+=1;		
		};

	return status;
	}


extern PricingMethod MET(CF_Call_Merton);
extern PricingMethod MET(CF_Put_Merton);
extern PricingMethod MET(AP_Call_Carr);
extern PricingMethod MET(AP_Put_Carr);
extern PricingMethod MET(MC_Merton);
extern PricingMethod MET(FD_AndersenAndreasen);
extern PricingMethod MET(FD_ImpExp);
extern PricingMethod MET(FD_Explicit);


PricingMethod* MOD_OPT(methods)[]={
                &MET(CF_Call_Merton),
		&MET(CF_Put_Merton),
		&MET(AP_Call_Carr),
		&MET(AP_Put_Carr),
		&MET(MC_Merton),
		&MET(FD_AndersenAndreasen),
		&MET(FD_ImpExp),
                &MET(FD_Explicit),
		NULL
	};

DynamicTest* MOD_OPT(tests)[]={
		NULL
	};

Pricing MOD_OPT(pricing)={
		ID_MOD_OPT,
		MOD_OPT(methods),
		MOD_OPT(tests),
		MOD_OPT(ChkMix)
	};

