#include "limdisc.h"

static NumFunc_1 call=
    {
    Call,
    {{"Strike",PDOUBLE,100,ALLOW},{" ",END,0,FORBID}},
    CHK_call
    };

static NumFunc_1 rebate=
    {
    Const,
    {{"Rebate",PDOUBLE,100,ALLOW},{" ",END,0,FORBID}},
    CHK_digit
    };

static NumFunc_1 limit=
    {
    ConstLim,
    {
        {"StartingDate",DATE,0,ALLOW},
        {"FinalDate",DATE,0,IRRELEVANT},
        {"Frequency",INT2,0,ALLOW},
        {"Limit",PDOUBLE,90,ALLOW},
        {" ",END,0,FORBID}
    },
    CHK_digit
    };

static TYPEOPT CallDownOutEuro=
    {
    /*PayOff*/      {"Payoff",NUMFUNC_1,0,FORBID},
    /*Rebate*/      {"Rebate",NUMFUNC_1,0,FORBID},
    /*OutOrIn*/     {"Out",BOOL,OUT,FORBID},
    /*DownOrUp*/    {"Down",BOOL,DOWN,FORBID},
    /*RebNo*/       {"Rebate",BOOL,NOREBATE,FORBID},
    /*EuOrAm*/      {"Euro",BOOL,EURO,FORBID},
    /*PartOrTot*/   {"Total",BOOL,TOTAL,FORBID},
    /*ContOrDisc*/  {"Disc",BOOL,DISC,FORBID},
    /*ConstLim*/    {"ConstLim",BOOL,CONSTLIM,ALLOW},
    /*Limit*/       {"Limit",NUMFUNC_1,0,FORBID},
    /*Maturity*/    {"Maturity",DATE,0,ALLOW}
    };

static int OPT(Init)(Option *opt)
    {
    TYPEOPT* pt=(  TYPEOPT*)(opt->TypeOpt);
    static int first=1;

    if (first)
        {
        pt->PayOff.Val.V_NUMFUNC_1=&call;
        pt->Rebate.Val.V_NUMFUNC_1=&rebate;
        pt->Limit.Val.V_NUMFUNC_1=&limit;

        (pt->PayOff.Val.V_NUMFUNC_1)->Par[0].Val.V_PDOUBLE=100.0;
        (pt->Rebate.Val.V_NUMFUNC_1)->Par[0].Val.V_PDOUBLE=10.0;

        (pt->OutOrIn).Val.V_BOOL=OUT;
        (pt->DownOrUp).Val.V_BOOL=DOWN;
        (pt->RebOrNo).Val.V_BOOL=NOREBATE;
        (pt->EuOrAm).Val.V_BOOL=EURO;
        (pt->PartOrTot).Val.V_BOOL=TOTAL;
        (pt->ContOrDisc).Val.V_BOOL=DISC;
        (pt->ConstLim).Val.V_BOOL=CONSTLIM;

        (pt->Limit.Val.V_NUMFUNC_1)->Par[0].Val.V_DATE=-1.;
        (pt->Limit.Val.V_NUMFUNC_1)->Par[2].Val.V_INT2=100;
        (pt->Limit.Val.V_NUMFUNC_1)->Par[3].Val.V_PDOUBLE=90.0;

        (pt->Maturity).Val.V_DATE=1.0;


        first=0;
        }

    return OK;
    }

MAKEOPT(CallDownOutEuro);
