#include  "pad.h"

static NumFunc_2 call=
    {
    Call_OverSpot2,
    {{"Strike",PDOUBLE,100,ALLOW},{" ",END,0,FORBID}},
    CHK_call
    };

static NumFunc_2 asian=
    {
    Asian,
        {
        {"StartingDate",DATE,0,ALLOW},
        {"FinalDate",DATE,0,IRRELEVANT},
        {"Frequency",PDOUBLE,0,IRRELEVANT},
        {"InitialValue",PDOUBLE,100,IRRELEVANT},
        {"Average",PDOUBLE,100,ALLOW},
        {" ",END,0,FORBID}
        },
        /*The average At at time t is given by: A0+S0+Sh+S2h+..+Snh/n with:*/
        /*h=Frequency, nh=t-StartingDate */
        /*frequency doesn't matter for continuous average*/
        CHK_call
    };

static TYPEOPT AsianCallFixedEuro=
    {
    /*PayOff*/      {"Payoff",NUMFUNC_2,0,FORBID},
    /*MinOrElse*/    {"Average",PADE,AVERAGE,ALLOW},
    /*EuOrAm*/       {"Euro",BOOL,EURO,FORBID},
    /*PartOrTot*/    {"Total",BOOL,TOTAL,FORBID},
    /*ContOrDisc*/   {"Continuous",BOOL,CONT,FORBID},
    /*PathDep*/     {"PathDep",NUMFUNC_2,0,FORBID},
    /*Maturity*/        {"Maturity",DATE,0,ALLOW}
    };

static int OPT(Init)(Option *opt)
    {
    TYPEOPT* pt=(  TYPEOPT*)(opt->TypeOpt);
    static int first=1;

    if (first)
        {
        pt->PayOff.Val.V_NUMFUNC_2=&call;
        pt->PathDep.Val.V_NUMFUNC_2=&asian;

        (pt->PayOff.Val.V_NUMFUNC_2)->Par[0].Val.V_PDOUBLE=100.0;

        (pt->MinOrElse).Val.V_PADE=AVERAGE;
        (pt->EuOrAm).Val.V_BOOL=EURO;
        (pt->PartOrTot).Val.V_BOOL=TOTAL;
        (pt->ContOrDisc).Val.V_BOOL=CONT;

        (pt->PathDep.Val.V_NUMFUNC_2)->Par[0].Val.V_DATE=0.0;
        (pt->PathDep.Val.V_NUMFUNC_2)->Par[1].Val.V_DATE=0.0;
        (pt->PathDep.Val.V_NUMFUNC_2)->Par[2].Val.V_PDOUBLE=0.0;
        (pt->PathDep.Val.V_NUMFUNC_2)->Par[3].Val.V_PDOUBLE=0.0;
        (pt->PathDep.Val.V_NUMFUNC_2)->Par[4].Val.V_PDOUBLE=0.0;

        (pt->Maturity).Val.V_DATE=1.0;

        first=0;
        }

    return OK;
    }

MAKEOPT(AsianCallFixedEuro);
