#include  "pad.h"

static NumFunc_2 put=
    {
    Put_OverSpot2,  /*(K-Minimum)+*/
    {{"Strike",PDOUBLE,100,ALLOW},{" ",END,0,FORBID}},
    CHK_call
    };

static NumFunc_2 minimum=
    {
    Minimum,
        {
        {"StartingDate",DATE,0,IRRELEVANT},
        {"FinalDate",DATE,0,IRRELEVANT},
        {"Frequency",PDOUBLE,0,IRRELEVANT},
        {"InitialValue",PDOUBLE,100,IRRELEVANT},
        {"Minimum",PDOUBLE,100,ALLOW},
        {" ",END,0,FORBID}
        },
        CHK_call
    };


TYPEOPT LookBackPutFixedAmer=
    {
    /*PayOff*/      {"Payoff",NUMFUNC_2,0,FORBID},
    /*MinOrElse*/    {"Minimum",PADE,MINIMUM,ALLOW},
    /*EuOrAm*/       {"Amer",BOOL,AMER,FORBID},
    /*PartOrTot*/    {"Total",BOOL,TOTAL,FORBID},
    /*ContOrDisc*/   {"Continuous",BOOL,CONT,FORBID},
    /*PathDep*/     {"PathDep",NUMFUNC_2,0,FORBID},
    /*Maturity*/        {"Maturity",DATE,0,ALLOW}
    };

static int OPT(Init)(Option *opt)
    {
    TYPEOPT* pt=(  TYPEOPT*)(opt->TypeOpt);
    static int first=1;

    if (first)
        {
        pt->PayOff.Val.V_NUMFUNC_2=&put;
        pt->PathDep.Val.V_NUMFUNC_2=&minimum;

        (pt->PayOff.Val.V_NUMFUNC_2)->Par[0].Val.V_PDOUBLE=100.0;

        (pt->MinOrElse).Val.V_PADE=MINIMUM;
        (pt->EuOrAm).Val.V_BOOL=AMER;
        (pt->PartOrTot).Val.V_BOOL=TOTAL;
        (pt->ContOrDisc).Val.V_BOOL=CONT;

        (pt->PathDep.Val.V_NUMFUNC_2)->Par[0].Val.V_DATE=0.0;
        (pt->PathDep.Val.V_NUMFUNC_2)->Par[1].Val.V_DATE=0.0;
        (pt->PathDep.Val.V_NUMFUNC_2)->Par[2].Val.V_PDOUBLE=0.0;
        (pt->PathDep.Val.V_NUMFUNC_2)->Par[3].Val.V_PDOUBLE=100.0;
        (pt->PathDep.Val.V_NUMFUNC_2)->Par[4].Val.V_PDOUBLE=100.0;

        (pt->Maturity).Val.V_DATE=1.0;

        first=0;
        }

    return OK;
    }

MAKEOPT(LookBackPutFixedAmer);
